﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;

namespace Yield_csharp
{
    class Program
    {
        static List<int> MyList = new List<int>();
        const int _max = 1000000;
        static void FillValues()
        {
            MyList.Add(1);
            MyList.Add(2);
            MyList.Add(3);
            MyList.Add(4);
            MyList.Add(5);
        }
        static void Main(string[] args) 
        {
            FillValues(); 

            var s1 = Stopwatch.StartNew();
            foreach (var item in FilterWithoutYield())
            {
                Console.WriteLine(item);
            }
            s1.Stop();
            var s2 = Stopwatch.StartNew();
            foreach (var item in FilterWithYield())
            {
                Console.WriteLine(item);
            }
            s2.Stop();

            Console.WriteLine(((double)(s1.Elapsed.TotalMilliseconds * 1000000) /
            _max).ToString("0.00 ns"));
            Console.WriteLine(((double)(s2.Elapsed.TotalMilliseconds * 1000000) /
                _max).ToString("0.00 ns"));

            foreach (int i in RunningTotal())
            {
                Console.WriteLine(i);
            }


            Console.ReadLine();
        }

        private static IEnumerable<int> FilterWithYield()
        {
            foreach (int i in MyList)
            {
                if (i > 3)
                {
                    yield return i;
                }
            }
        }

        static IEnumerable<int> FilterWithoutYield()
        {
            List<int> temp = new List<int>();
            foreach (int i in MyList)
            {
                if (i > 3)
                {
                    temp.Add(i);
                }
            }
            return temp;
        }

        static IEnumerable<int> RunningTotal()
        {
            int runningtotal = 0;
            foreach (int i in MyList)
            {
                runningtotal += i;
                yield return (runningtotal);

            }
        }
    }
}
